Bug 105380 - Segfault with strange title (Invalid UTF-8?)
Segfault with strange title (Invalid UTF-8?)
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: vte (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Brian Stein
David Lawrence
:
Depends On:
Blocks: CambridgeTarget
  Show dependency treegraph
 
Reported: 2003-09-25 12:02 EDT by Brian Stein
Modified: 2013-03-01 00:14 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-08-02 14:09:03 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
file to cat to reproduce (43.21 KB, text/plain)
2003-09-25 12:03 EDT, Arjan van de Ven
no flags Details

  None (edit)
Description Arjan van de Ven 2003-09-25 12:02:22 EDT
Description of problem:

It segfaults. It shouldn;t.

#0  0x00abfc02 in _dl_sysinfo_int80 () at rtld.c:274
#1  0x00d44763 in __waitpid_nocancel () from /lib/tls/libpthread.so.0
#2  <signal handler called>
#3  pango_layout_iter_get_char_extents (iter=0x9211f98, logical_rect=0x93ff618)
at pango-layout.c:4456
#4  0x0807b3ef in compute_character_widths (
    string=0x9211f98 "�\216��\216��\216��\224\234@�\224\224�\226\222�\216��\224
\234�\220\212�\216�:/�\224��\2
26\222�\216�/�\224\214�\216�±/�\224\234�\224\234�\211��\224��\226\222�\224\234�
\220\214�\220�", 
    context=0x93ff618, list=0xfffffe00, char_len_return=0xfffffe00,
widths_return=0xfffffe00, 
    cuts_return=0xfffffe00) at eel-pango-extensions.c:180
#5  0x0807b6fd in eel_string_ellipsize_end (
    string=0x9211f98 "�\216��\216��\216��\224\234@�\224\224�\226\222�\216��\224
\234�\220\212�\216�:/�\224��\2
26\222�\216�/�\224\214�\216�±/�\224\234�\224\234�\211��\224��\226\222�\224\234�
\220\214�\220�", 
    layout=0x9, width=157) at eel-pango-extensions.c:327
#6  0x0807ba8e in eel_pango_layout_set_text_ellipsized (layout=0x93632c8, 
    string=0x9211f98 "�\216��\216��\216��\224\234@�\224\224�\226\222�\216��\224
\234�\220\212�\216�:/�\224��\2
26\222�\216�/�\224\214�\216�±/�\224\234�\224\234�\211��\224��\226\222�\224\234�
\220\214�\220�", width=169, 
    mode=EEL_ELLIPSIZE_END) at eel-pango-extensions.c:478
#7  0x0807adac in real_size_allocate (widget=0x9400fc8, allocation=0xbff9a060)
    at eel-ellipsizing-label.c:124
#8  0x00551bae in g_cclosure_marshal_VOID__BOXED (closure=0x918a538,
return_value=0x0, n_param_values=2, 
    param_values=0xbff99ea0, invocation_hint=0xbff99da8, marshal_data=0x807ac40)
at gmarshal.c:566
#9  0x0053f007 in g_type_class_meta_marshal (closure=0xbff99ea0,
return_value=0xfffffe00, 
    n_param_values=4294966784, param_values=0x918a538,
invocation_hint=0xfffffe00, marshal_data=0xfffffe00)
    at gclosure.c:514
#10 0x0053ecb0 in g_closure_invoke (closure=0x918a538, return_value=0xfffffe00,
n_param_values=4294966784, 
    param_values=0xfffffe00, invocation_hint=0xfffffe00) at gclosure.c:437
#11 0x0055049d in signal_emit_unlocked_R (node=0x918ac18, detail=0,
instance=0x9400fc8, 
    emission_return=0x0, instance_and_params=0xbff99ea0) at gsignal.c:2752
#12 0x0054fc36 in g_signal_emit_valist (instance=0x9400fc8, signal_id=152610104,
detail=0, 
    var_args=0xbff9a030 "�\017@\t�\001") at gsignal.c:2554
#13 0x0054fe74 in g_signal_emit (instance=0xfffffe00, signal_id=4294966784,
detail=4294966784)
    at gsignal.c:2612
#14 0x0394654f in gtk_widget_size_allocate (widget=0xbff99ea0,
allocation=0x918a538) at gtkwidget.c:2451
#15 0x0387c2f1 in gtk_notebook_page_allocate (notebook=0x919d868,
page=0x9266a98, allocation=0x1)
Comment 1 Arjan van de Ven 2003-09-25 12:03:48 EDT
Created attachment 94721 [details]
file to cat to reproduce

cat the attached file in a tab inside GT and then resize the bottom bar of the
terminal -> boom
Comment 2 Owen Taylor 2003-09-25 12:08:15 EDT
I think:

 A) VTE or gnome-terminal needs to validate the UTF-8 data it
    is getting for the title
 B) eel-ellipsized label needs to validate UTF-8 as well

It's conceivable that it's not a invalid-UTF-8 problem, but rather
just some problem that the particular string is triggering.

What locale are you running in, Arjan? (UTF-8 vs. ISO-8859-15 
is likely relevant.)
Comment 3 Arjan van de Ven 2003-09-25 12:10:42 EDT
en_US.UTF-8
Comment 4 Arjan van de Ven 2003-09-25 12:14:17 EDT
gnome-terminal-2.4.0.1-1
vte-0.11.10-4
pango-1.2.5-1.1
fwiw
Comment 5 Havoc Pennington 2003-09-25 15:38:13 EDT
Reading the VTE source code it certainly seems to validate the title.
In any case if the title were invalid my memory is that GTK+ and Pango will
g_return_if_fail(), rather than crashing down in the guts of things like this.
Comment 6 Arjan van de Ven 2003-09-25 16:08:52 EDT
btw this happened twice not once; same thing
(basically a box I ssh'd into oopsed ... boom :)
so it's kind of repeatable
Comment 7 Havoc Pennington 2003-10-04 02:15:11 EDT
This is either vte or pango, terminal should be getting valid UTF-8 from vte.
Comment 8 Warren Togami 2005-03-29 03:03:17 EST
Arjan are you still able to reproduce this?
Comment 9 Warren Togami 2005-09-11 06:41:30 EDT
vte-0.11.14 rendering and even the titlebar becomes corrupted when I cat this
file in FC4.
Comment 10 Matthias Clasen 2006-08-02 14:09:03 EDT
I don't get a segfault on catting this file, and the display goes back to normal
with a simple reset. This is with 0.13.5. Therefore, I assume this is fixed. If
you are able to reproduce in rawhide, please reopen.

Note You need to log in before you can comment on or make changes to this bug.